package com.dsic.gj_erp.controller.fd;

import com.alibaba.excel.EasyExcel;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.fd.ExcelExport;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.listeners.ExcelFdListener;
import com.dsic.gj_erp.service.fd.DmCzfddybService;
import io.swagger.annotations.Authorization;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/api/dmCzfddyb")
@AllArgsConstructor
public class DmCzfddybController {
    private final DmCzfddybService dmCzfddybService;
    
    @PostMapping("/upload")
    @Authorization("")
    @ResponseBody
    public ResultBean upload(@RequestParam("file") MultipartFile file , String czbh, String isupload, HttpServletRequest req) throws Exception, CustomException {
        ExcelFdListener objectListener = new ExcelFdListener();
        EasyExcel.read(file.getInputStream(), ExcelExport.class, objectListener).sheet(0).headRowNumber(0).doRead();
        List<ExcelExport> objList = objectListener.getObjectList();
        Map map = dmCzfddybService.uploadFd(req, objList, czbh,isupload);
        return new ResultBean(map);
    }

    @PostMapping("/getCzFdBase")
    @Authorization("")
    public ResultBean getCzFdBase( HttpServletRequest req,@RequestBody Map<String, Object> map) {

        Map rmap = dmCzfddybService.getCzFdBase(req,map);
        return new ResultBean(rmap);
    }
    @PostMapping("/getList")
    @Authorization("")
    public ResultBean getList( HttpServletRequest req,@RequestBody Map<String, Object> map) throws Exception {

        Map rmap = dmCzfddybService.getList(map);
        return new ResultBean(rmap);
    }

    @PostMapping("/getTpBase")
    @Authorization("")
    public ResultBean getTpBase( HttpServletRequest req,@RequestBody Map<String, Object> map) throws Exception {

        Map rmap = dmCzfddybService.getTpBase(req,map);
        return new ResultBean(rmap);
    }
    @PostMapping("/getListFdMx")
    @Authorization("")
    public ResultBean getListFdMx( HttpServletRequest req,@RequestBody Map<String, Object> map) throws Exception {

        Map rmap = dmCzfddybService.getListFdMx(map);
        return new ResultBean(rmap);
    }

}
