package com.dsic.gj_erp.controller.jcsj;


import com.alibaba.excel.EasyExcel;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.DmCzplpNew;
import com.dsic.gj_erp.bean.jcsj.excel.PlExcel;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.listeners.ExcelPlListener;
import com.dsic.gj_erp.service.jcsj.DmCzplpNewService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-11
 */
@RestController
@RequestMapping("/dmCzplpNew")
public class DmCzplpNewController {

        @Autowired
    DmCzplpNewService dmCzplpNewService;


    @PostMapping("/uploadPl")
    @AuthFunction
    @ResponseBody
    public ResultBean uploadPl(@RequestParam("file") MultipartFile file , String czbh, String isupload, HttpServletRequest req) throws Exception, CustomException {

        ExcelPlListener objectListener = new ExcelPlListener();
        EasyExcel.read(file.getInputStream(), PlExcel.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<PlExcel> objList = objectListener.getObjectList();
        Map map = dmCzplpNewService.uploadPl(objList, czbh, isupload,req);
        return new ResultBean(map);
    }


    @PostMapping("/getCzplBase")
    @AuthFunction
    @ResponseBody
    public ResultBean getCzplBase(HttpServletRequest req,@RequestBody Map<String, Object> map) throws Exception, CustomException {

        return new ResultBean(dmCzplpNewService.getCzplBase(map));

    }

    @PostMapping("/czPlupdate")
    @AuthFunction
    @ResponseBody
    public ResultBean czPlupdate(HttpServletRequest req, @RequestBody List<DmCzplpNew> dmCzplpNews) throws Exception, CustomException {
        dmCzplpNewService.czPlupdate(dmCzplpNews);
        return new ResultBean();

    }

    @PostMapping("/czPlDel")
    @AuthFunction
    @ResponseBody
    public ResultBean czPlDel(HttpServletRequest req, @RequestBody List<DmCzplpNew> dmCzplpNews) throws Exception, CustomException {

        dmCzplpNews.forEach(e->{
            dmCzplpNewService.removeById(e.getId());
        });

        return new ResultBean();

    }
    @PostMapping("/getCzplList")
    @ResponseBody
    public ResultBean getCzplList(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
//        dmCzplpNewService.getCzplList(map);
        return new ResultBean(dmCzplpNewService.getCzplList(map));

    }

}

