package com.dsic.gj_erp.listeners;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.dsic.gj_erp.bean.fd.ExcelExport;
import com.dsic.gj_erp.util.ObjConvertUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class ExcelFdListener extends AnalysisEventListener<ExcelExport> {
    private static final int BATCH_COUNT = 5;

    List<ExcelExport> objectList = new ArrayList<>();
    List<Object> headList = new ArrayList<>();
    private String sheetName;

    List<ExcelExport> datas = new ArrayList<ExcelExport>();

    @Override
    public void invoke(ExcelExport excelDemo, AnalysisContext analysisContext) {
        //每解析一行数据，就会调用该方法一次
        //正常在这里调用数据处理得办法

        //一条数据添加到暂时存储的存储结构中

        boolean b = ObjConvertUtils.checkObjAllFieldsIsNull(excelDemo);
        if(!b){
            datas.add(excelDemo);
        }






        // 达到BATCH_COUNT了，需要去存储一次数据库，防止数据几万条数据在内存，容易OOM
        if (datas.size() >= BATCH_COUNT) {
            saveData();
            // 存储完成清理 list
            datas.clear();
        }
    }




    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        //获取sheetName
        saveData();
        sheetName = context.readSheetHolder().getSheetName();
//        LOGGER.info("所有数据解析完成！");
    }

    //获取表头
    @Override
    public void invokeHeadMap(Map<Integer, String> headMap, AnalysisContext context) {
        //把表头数据加入到存储结构中
        headList.add(headMap);
    }

    /**
     * 入库
     */
    private void saveData() {
        //添加到返回的存储结构中，也可直接存储到数据库
        objectList.addAll(datas);
    }

    public List<ExcelExport> getDatas() {
        return datas;
    }

    public void setDatas(List<ExcelExport> datas) {
        this.datas = datas;
    }

    public List<ExcelExport> getObjectList() {
        return objectList;
    }

    public void setObjectList(List<ExcelExport> objectList) {
        this.objectList = objectList;
    }

    public String getSheetName() {
        return sheetName;
    }

    public void setSheetName(String sheetName) {
        this.sheetName = sheetName;
    }

    public List<Object> getHeadList() {
        return headList;
    }

    public void setHeadList(List<Object> headList) {
        this.headList = headList;
    }
}
